/* fbell -- match incoming list against a collection of stored templates. */

/*  Copyright 1999 Miller Puckette.
Permission is granted to use this software for any purpose provided you
keep this copyright notice intact.

THE AUTHOR AND HIS EMPLOYERS MAKE NO WARRANTY, EXPRESS OR IMPLIED,
IN CONNECTION WITH THIS SOFTWARE.
 
This file is downloadable from http://www.crca.ucsd.edu/~msp .
*/

#include "m_pd.h"
#include <math.h>
#include <stdlib.h>
static t_class *fbell_class;
#define NOSC 16
#define MAXPARTIAL 20

typedef struct _fbell
{
    t_object x_obj;
} t_fbell;

static void *fbell_new(t_float fnonrepeat)
{
    t_fbell *x = (t_fbell *)pd_new(fbell_class);
    outlet_new(&x->x_obj, gensym("list"));
    return (x);
}

static int signit(int f)
{
    if (f & 1)
        return ((f+1)/2);
    else return (- (f/2));
}

static void fbell_list(t_fbell *x, t_symbol *s, int argc, t_atom *argv)
{
    int i, j, k, nsent = 0;
    static unsigned int state;
    int prob = atom_getfloatarg(0, argc, argv);
    float seed = atom_getfloatarg(1, argc, argv);
    float f1 = atom_getfloatarg(2, argc, argv);
    float f2 = atom_getfloatarg(3, argc, argv);
    float f3 = atom_getfloatarg(4, argc, argv);
    if (prob < 3)
        prob = 3;
    if (seed == 0)
        state = random();
    else state = seed;
    for (i = 0; i < MAXPARTIAL; i++)
        for (j = 0; j <= i; j++)
            for (k = 0; k <= j; k++)
    {
        int myrandom;
        state = state * 472940017 + 832416023;
        myrandom = (100. * (float)state) * (1./4294967296.);
        if (myrandom >= 100)
            myrandom = 99;
        if (f1*signit(k) + f2*signit(j-k) + f3*signit(i-j) < 1)
            continue;
        if (myrandom < prob)
        {
            t_atom at[4];
            SETFLOAT(at, f1*signit(k) + f2*signit(j-k) + f3*signit(i-j));
            SETFLOAT(at+1, signit(k));
            SETFLOAT(at+1, signit(j-k));
            SETFLOAT(at+2, signit(i-j));
            outlet_list(x->x_obj.ob_outlet, 0, 4, at);
            nsent++;
            if (nsent > NOSC)
                return;
        }
    }
}

void fbell_setup(void)
{
    fbell_class = class_new(gensym("fbell"), (t_newmethod)fbell_new,
        0, sizeof(t_fbell), 0, A_DEFFLOAT, 0);
    class_addlist(fbell_class, fbell_list);
}
